<?php
require_once( LIB_DIR . 'Prototype' . DS . 'class.PTPlugin.php' );

class FBEmbeddedPosts extends PTPlugin {

    function __construct () {
        parent::__construct();
    }

    function hdlr_facebookembed ( $args, $ctx ) {
        $href = $args['url'] ?? null;
        if (! $href || strpos( $href, 'https://www.facebook.com/' ) !== 0 ) {
            return;
        }
        $content = $args['content'] ?? null;
        $footer = isset( $args['footer'] ) ? $args['footer'] : true;
        if ( $footer === 'false' ) {
            $footer = false;
        }
        unset( $args['url'], $args['this_tag'], $args['content'], $args['foooter'] );
        $division = 'div class="fb-post" data-href="' . $href . '"';
        foreach ( $args as $attr => $value ) {
            $attr = str_replace( '_', '-', $attr );
            $division .= " data-{$attr}=\"" . $value . '"';
        }
        if (! isset( $args['width'] ) ) {
            $division .= ' data-width="500"';
        }
        if (! isset( $args['show-text'] ) && ! isset( $args['show_text'] ) ) {
            $division .= ' data-show-text="true"';
        }
        $division = "<{$division}>" . PHP_EOL;
        $division .= '<blockquote cite="' . $href . '" class="fb-xfbml-parse-ignore">' . PHP_EOL;
        $author_url = preg_replace( '!(^https://www.facebook.com/[^/]*?)/.*$!', '$1', $href );
        $author_basename = basename( $author_url );
        $author_basename = $this->translate( "%s's Post", $author_basename );
        if ( $content ) {
            $content = str_replace( '<!--facebook_embed_url-->', $href, $content );
            $content = str_replace( '<!--facebook_author_url-->', $author_url, $content );
            $content = str_replace( '<!--facebook_author_basename-->', $author_basename, $content );
            $division .= $content;
        } else {
            $division .= '<ul>' . PHP_EOL . '<li><a href="' . $author_url . '">' . $author_basename . '</a></li>' . PHP_EOL;
            $division .= '<li><a href="' . $href . '">' . $this->translate( 'View Post' ) . '</a></li>' . PHP_EOL . '</ul>';
        }
        $division .= PHP_EOL . '</blockquote>' . PHP_EOL . '</div>';
        if ( $footer ) {
            $footer = '<div id="fb-root"></div>' . PHP_EOL;
            $footer .= '<script async defer crossorigin="anonymous" src="https://connect.facebook.net/ja_JP/sdk.js#xfbml=1&version=v';
            $v = $this->get_config_value( 'fbembeddedposts_sdk_version' );
            $footer .= $v;
            $footer .= '"></script>';
            $division .= PHP_EOL . $footer;
        }
        return $division;
    }

    function filter_convert_fb_embed ( $text, $arg, $ctx ) {
        if ( preg_match( '!<p>\s*<iframe[^>]*src="https://www\.facebook\.com/plugins/post\.php\?.*?"[^>]*>.*?</iframe>\s*</p>!si', $text, $matches ) ) {
            $text = preg_replace( '!<p>(<iframe[^>]*src="https://www\.facebook\.com/plugins/post\.php\?.*?"[^>]*>.*?</iframe>)</p>!si', '$1', $text );
        }
        if ( preg_match_all( '!<iframe[^>]*src="https://www\.facebook\.com/plugins/post\.php\?(.*?)"[^>]*>.*?</iframe>!si', $text, $matches ) ) {
            $iframes = $matches[0];
            $sources = $matches[1];
            foreach ( $iframes as $idx => $iframe ) {
                $source = urldecode( $sources[0] );
                parse_str( html_entity_decode( $source ), $params );
                $href = $params['href'] ?? null;
                if (! $href ) continue;
                $division = 'div class="fb-post"';
                foreach ( $params as $attr => $value ) {
                    $attr = str_replace( '_', '-', $attr );
                    $division .= " data-{$attr}=\"" . $value . '"';
                }
                $division = "<{$division}>" . PHP_EOL;
                $division .= '<blockquote cite="' . $href . '" class="fb-xfbml-parse-ignore">' . PHP_EOL;
                $author_url = preg_replace( '!(^https://www.facebook.com/[^/]*?)/.*$!', '$1', $href );
                $author_basename = basename( $author_url );
                $author_basename = $this->translate( "%s's Post", $author_basename );
                $division .= '<ul>' . PHP_EOL . '<li><a href="' . $author_url . '">' . $author_basename . '</a></li>' . PHP_EOL;
                $division .= '<li><a href="' . $href . '">' . $this->translate( 'View Post' ) . '</a></li>' . PHP_EOL . '</ul>';
                $division .= PHP_EOL . '</blockquote>' . PHP_EOL . '</div>' . PHP_EOL;
                $text = str_replace( $iframe, $division, $text );
            }
            $footer = '<div id="fb-root"></div>' . PHP_EOL;
            $footer .= '<script async defer crossorigin="anonymous" src="https://connect.facebook.net/ja_JP/sdk.js#xfbml=1&version=v';
            $v = $this->get_config_value( 'fbembeddedposts_sdk_version' );
            $footer .= $v;
            $footer .= '"></script>';
            $text .= $footer;
        }
        return $text;
    }

}